Imports Microsoft.VisualBasic
Imports System.Globalization
Imports System.Windows
Imports System.Windows.Markup
Imports DemoApp.ViewModel
Imports System

Namespace DemoApp
	Partial Public Class App
        Inherits Application
        Private viewModel As MainWindowViewModel
        Private window As MainWindow

		Shared Sub New()
			' This code is used to test the app when using other cultures.
			'
			'System.Threading.Thread.CurrentThread.CurrentCulture =
			'    System.Threading.Thread.CurrentThread.CurrentUICulture =
			'        new System.Globalization.CultureInfo("it-IT");


			' Ensure the current culture passed into bindings is the OS culture.
			' By default, WPF uses en-US as the culture, regardless of the system settings.
			'
			FrameworkElement.LanguageProperty.OverrideMetadata(GetType(FrameworkElement), New FrameworkPropertyMetadata(XmlLanguage.GetLanguage(CultureInfo.CurrentCulture.IetfLanguageTag)))
		End Sub

		Protected Overrides Sub OnStartup(ByVal e As StartupEventArgs)
			MyBase.OnStartup(e)

            window = New MainWindow

			' Create the ViewModel to which 
			' the main window binds.
			Dim path As String = "Data/customers.xml"
            viewModel = New MainWindowViewModel(path)

			' When the ViewModel asks to be closed, 
			' close the window.
            AddHandler viewModel.RequestClose, AddressOf RemoveRequestCloseHandler

			' Allow all controls in the window to 
			' bind to the ViewModel by setting the 
			' DataContext, which propagates down 
			' the element tree.
			window.DataContext = viewModel

			window.Show()
        End Sub

        Private Sub RemoveRequestCloseHandler(ByVal sender As Object, ByVal e As EventArgs)
            RemoveHandler viewModel.RequestClose, AddressOf RemoveRequestCloseHandler
            Window.Close()
        End Sub
    End Class
End Namespace