Imports Microsoft.VisualBasic
Imports System
Imports System.Windows.Input

Namespace DemoApp.ViewModel
	''' <summary>
	''' Represents an actionable item displayed by a View.
	''' </summary>
	Public Class CommandViewModel
		Inherits ViewModelBase
		Public Sub New(ByVal displayName As String, ByVal command As ICommand)
			If command Is Nothing Then
				Throw New ArgumentNullException("command")
			End If

			MyBase.DisplayName = displayName
			Me.Command = command
		End Sub

		Private privateCommand As ICommand
		Public Property Command() As ICommand
			Get
				Return privateCommand
			End Get
			Private Set(ByVal value As ICommand)
				privateCommand = value
			End Set
		End Property
	End Class
End Namespace