Imports Microsoft.VisualBasic
Imports System
Imports DemoApp.DataAccess
Imports DemoApp.Model
Imports Microsoft.VisualStudio.TestTools.UnitTesting

Namespace UnitTests
    <TestClass()> _
    Public Class CustomerRepositoryTests
        Private eventArgIsValid As Boolean
        Private cust As Customer

#Region "Boilerplate Code"

        Public Sub New()
        End Sub

        Private testContextInstance As TestContext

        ''' <summary>
        '''Gets or sets the test context which provides
        '''information about and functionality for the current test run.
        '''</summary>
        Public Property TestContext() As TestContext
            Get
                Return testContextInstance
            End Get
            Set(ByVal value As TestContext)
                testContextInstance = value
            End Set
        End Property

#Region "Additional test attributes"
        '
        ' You can use the following additional attributes as you write your tests:
        '
        ' Use ClassInitialize to run code before running the first test in the class
        ' [ClassInitialize()]
        ' public static void MyClassInitialize(TestContext testContext) { }
        '
        ' Use ClassCleanup to run code after all tests in a class have run
        ' [ClassCleanup()]
        ' public static void MyClassCleanup() { }
        '
        ' Use TestInitialize to run code before running each test 
        ' [TestInitialize()]
        ' public void MyTestInitialize() { }
        '
        ' Use TestCleanup to run code after each test has run
        ' [TestCleanup()]
        ' public void MyTestCleanup() { }
        '
#End Region

#End Region ' Boilerplate Code

        <TestMethod()> _
        Public Sub TestAllCustomersAreLoaded()
            Dim target As New CustomerRepository(Constants.CUSTOMER_DATA_FILE)
            Assert.AreEqual(3, target.GetCustomers().Count, "Invalid number of customers in repository.")
        End Sub

        <TestMethod()> _
        Public Sub TestNewCustomerIsAddedProperly()
            Dim target As New CustomerRepository(Constants.CUSTOMER_DATA_FILE)
            cust = Customer.CreateNewCustomer()

            AddHandler target.CustomerAdded, AddressOf CustomerAddedHandler
            target.AddCustomer(cust)

            Assert.IsTrue(eventArgIsValid, "Invalid NewCustomer property")
            Assert.IsTrue(target.ContainsCustomer(cust), "New customer was not added")
        End Sub

        Private Sub CustomerAddedHandler(ByVal sender As Object, ByVal e As CustomerAddedEventArgs)
            eventArgIsValid = (e.NewCustomer Is cust)
        End Sub

    End Class
End Namespace