Imports Microsoft.VisualBasic
Imports System
Imports DemoApp.Model
Imports Microsoft.VisualStudio.TestTools.UnitTesting

Namespace UnitTests
	<TestClass> _
	Public Class CustomerTests
		#Region "Boilerplate Code"

		Private testContextInstance As TestContext

		''' <summary>
		'''Gets or sets the test context which provides
		'''information about and functionality for the current test run.
		'''</summary>
		Public Property TestContext() As TestContext
			Get
				Return testContextInstance
			End Get
			Set(ByVal value As TestContext)
				testContextInstance = value
			End Set
		End Property

		#Region "Additional test attributes"
		' 
		'You can use the following additional attributes as you write your tests:
		'
		'Use ClassInitialize to run code before running the first test in the class
		'[ClassInitialize]
		'public static void MyClassInitialize(TestContext testContext)
		'{
		'}
		'
		'Use ClassCleanup to run code after all tests in a class have run
		'[ClassCleanup]
		'public static void MyClassCleanup()
		'{
		'}
		'
		'Use TestInitialize to run code before running each test
		'[TestInitialize]
		'public void MyTestInitialize()
		'{
		'}
		'
		'Use TestCleanup to run code after each test has run
		'[TestCleanup]
		'public void MyTestCleanup()
		'{
		'}
		'
		#End Region

		#End Region ' Boilerplate Code

		<TestMethod> _
		Public Sub TestIsValidPerson()
			Dim target As Customer = Customer.CreateNewCustomer()
			target.IsCompany = False
			target.FirstName = "Lloyd"
			target.LastName = "Christmas"
			target.Email = "lloyd@acme.com"

			Assert.IsTrue(target.IsValid, "Should be valid")
		End Sub

		<TestMethod> _
		Public Sub TestIsValidCompany()
			Dim target As Customer = Customer.CreateNewCustomer()
			target.IsCompany = True
			target.FirstName = "Acme, Inc."
			target.Email = "email@acme.com"

			Assert.IsTrue(target.IsValid, "Should be valid")
		End Sub

		<TestMethod> _
		Public Sub TestIsInvalidPersonIfEmpty()
			Dim target As Customer = Customer.CreateNewCustomer()

			Assert.IsFalse(target.IsValid, "Should be invalid")
		End Sub

		<TestMethod> _
		Public Sub TestIsInvalidCompanyIfLastNameExists()
			Dim target As Customer = Customer.CreateNewCustomer()
			target.IsCompany = True
			target.FirstName = "Acme, Inc."
			target.LastName = "foobar!"
			target.Email = "email@acme.com"

			Assert.IsFalse(target.IsValid, "Should be invalid")
		End Sub
	End Class
End Namespace