Imports DemoApp.Properties
Imports System
Imports System.ComponentModel
Imports DemoApp.DataAccess
Imports DemoApp.Model
Imports DemoApp.ViewModel
Imports Microsoft.VisualStudio.TestTools.UnitTesting

Namespace UnitTests
	<TestClass> _
	Public Class CustomerViewModelTests
		#Region "Boilerplate Code"

		Public Sub New()
		End Sub

		Private testContextInstance As TestContext

		''' <summary>
		'''Gets or sets the test context which provides
		'''information about and functionality for the current test run.
		'''</summary>
		Public Property TestContext() As TestContext
			Get
				Return testContextInstance
			End Get
			Set(ByVal value As TestContext)
				testContextInstance = value
			End Set
		End Property

		#Region "Additional test attributes"
		'
		' You can use the following additional attributes as you write your tests:
		'
		' Use ClassInitialize to run code before running the first test in the class
		' [ClassInitialize()]
		' public static void MyClassInitialize(TestContext testContext) { }
		'
		' Use ClassCleanup to run code after all tests in a class have run
		' [ClassCleanup()]
		' public static void MyClassCleanup() { }
		'
		' Use TestInitialize to run code before running each test 
		' [TestInitialize()]
		' public void MyTestInitialize() { }
		'
		' Use TestCleanup to run code after each test has run
		' [TestCleanup()]
		' public void MyTestCleanup() { }
		'
		#End Region

		#End Region ' Boilerplate Code

		<TestMethod> _
		Public Sub TestCustomerType()
			Dim cust As Customer = Customer.CreateNewCustomer()
			Dim repos As New CustomerRepository(Constants.CUSTOMER_DATA_FILE)
			Dim target As New CustomerViewModel(cust, repos)

			target.CustomerType = Strings.CustomerViewModel_CustomerTypeOption_Company
			Assert.IsTrue(cust.IsCompany, "Should be a company")

			target.CustomerType = Strings.CustomerViewModel_CustomerTypeOption_Person
			Assert.IsFalse(cust.IsCompany, "Should be a person")

			target.CustomerType = Strings.CustomerViewModel_CustomerTypeOption_NotSpecified
			Dim [error] As String = (TryCast(target, IDataErrorInfo))("CustomerType")
			Assert.IsFalse(String.IsNullOrEmpty([error]), "Error message should be returned")
		End Sub
	End Class
End Namespace