Imports System.ComponentModel
Imports Microsoft.VisualBasic
Imports System
Imports DemoApp.ViewModel
Imports Microsoft.VisualStudio.TestTools.UnitTesting

Namespace UnitTests
    <TestClass()> _
    Public Class ViewModelBaseTests
        Private eventWasRaised As Boolean
        Private Const PropertyName As String = "GoodProperty"
#Region "Boilerplate Code"

        Public Sub New()
        End Sub

        Private testContextInstance As TestContext

        ''' <summary>
        '''Gets or sets the test context which provides
        '''information about and functionality for the current test run.
        '''</summary>
        Public Property TestContext() As TestContext
            Get
                Return testContextInstance
            End Get
            Set(ByVal value As TestContext)
                testContextInstance = value
            End Set
        End Property

#Region "Additional test attributes"
        '
        ' You can use the following additional attributes as you write your tests:
        '
        ' Use ClassInitialize to run code before running the first test in the class
        ' [ClassInitialize()]
        ' public static void MyClassInitialize(TestContext testContext) { }
        '
        ' Use ClassCleanup to run code after all tests in a class have run
        ' [ClassCleanup()]
        ' public static void MyClassCleanup() { }
        '
        ' Use TestInitialize to run code before running each test 
        ' [TestInitialize()]
        ' public void MyTestInitialize() { }
        '
        ' Use TestCleanup to run code after each test has run
        ' [TestCleanup()]
        ' public void MyTestCleanup() { }
        '
#End Region

#End Region ' Boilerplate Code

        <TestMethod()> _
        Public Sub TestPropertyChangedIsRaisedCorrectly()
            Dim target As New TestViewModel()
            eventWasRaised = False
            AddHandler target.PropertyChanged, AddressOf PropertyChangedHandler
            target.GoodProperty = "Some new value..."
            Assert.IsTrue(eventWasRaised, "PropertyChanged event was not raised correctly.")
        End Sub

        <TestMethod()> _
        Public Sub TestExceptionIsThrownOnInvalidPropertyName()
            Dim target As New TestViewModel()
            Try
                target.BadProperty = "Some new value..."
#If DEBUG Then
                Assert.Fail("Exception was not thrown when invalid property name was used in DEBUG build.")
#End If
            Catch e1 As Exception
#If (Not DEBUG) Then
				Assert.Fail("Exception was thrown when invalid property name was used in RELEASE build.")
#End If
            End Try
        End Sub

        Private Sub PropertyChangedHandler(ByVal sender As Object, ByVal e As PropertyChangedEventArgs)
            eventWasRaised = e.PropertyName.Equals(PropertyName)
        End Sub
        Private Class TestViewModel
            Inherits ViewModelBase
            Protected Overrides Property ThrowOnInvalidPropertyName() As Boolean
                Get
                    Return True
                End Get
                Set(ByVal value As Boolean)
                    MyBase.ThrowOnInvalidPropertyName = value
                End Set
            End Property

            Public Property GoodProperty() As String
                Get
                    Return Nothing
                End Get
                Set(ByVal value As String)
                    MyBase.OnPropertyChanged("GoodProperty")
                End Set
            End Property

            Public Property BadProperty() As String
                Get
                    Return Nothing
                End Get
                Set(ByVal value As String)
                    MyBase.OnPropertyChanged("ThisIsAnInvalidPropertyName!")
                End Set
            End Property
        End Class
    End Class
End Namespace